# tuyaos_demo_zg_door_sensor



## 简介

`tuyaos_demo_zg_door_sensor`  示例的目的是在体现 TuyaOS Zigbee `Sleepy end device`设备的基本能力下，提供一个尽可能简单的示例。方便开发者借助此示例熟悉 TuyaOS 开发流程，验证手上的模组是否能够正常配网和测试zigbee基础功能。

## 环境准备

### 硬件环境

| 模组     | ZSU/ZS3L/ZS2S/ZSLC5等            |
| -------- | -------------------------------- |
| 芯片平台 | EFR32MG21F1024<br/>EFR32MG21F768 |****

| 模组     | ZT3L,ZTLC5,ZTU,ZT5,ZT2S,ZTC等     |
| -------- | -------------------------------- |
| 芯片平台 | TLSR8258F1KET                      |

### 引脚配置

在 `tuya_sdk_callback.h` 中可以修改示例的配网重置引脚和配网指示灯引脚。

EFR32MG21 平台

| 丝印名称 |                          备注                          |
| :------: | :----------------------------------------------------: |
|   PA3    |                告警触发引脚，高电平有效                |
|   PA0    |                防拆触发引脚，高电平有效                |
|   PA4    |                故障触发引脚，高电平有效                |
|   PD1    |                 状态指示灯，高电平有效                 |
|   PD2    |                 配网指示灯，高电平有效                 |
|   PB0    | 按键引脚，低电平有效，长按3s触发设备本地重置并开始扫网 |

TLSR8258F1KET平台 

| 丝印名称 |                          备注                          |
| :------: | :----------------------------------------------------: |
|   PD4    |                告警触发引脚，高电平有效                |
|   PB5    |                防拆触发引脚，高电平有效                |
|   PB4    |                故障触发引脚，高电平有效                |
|   PC2    |                 状态指示灯，高电平有效                 |
|   PC3    |                 配网指示灯，高电平有效                 |
|   PC0    | 按键引脚，低电平有效，长按3s触发设备本地重置并开始扫网 |
|   PC4    | GPIO 模拟串口进行打印，可以指定某个GPIO进行log输出 |

> 注意：这里的 GPIO 设置需要开发者根据不同模组实际情况进行配置。

### 软件环境

使用 `Tuya Wind IDE` 工具获取到此演示程序的开发者，不需要额外的环境准备。其他渠道获取此演示程序的开发者，可以参照[环境搭建](https://developer.tuya.com/cn/docs/iot-device-dev/tuyaos-wind-ide?id=Kbfy6kfuuqqu3)指引，来完成开发环境的搭建。



## DEMO功能介绍

| 配网触发     | 长按配网按键3s                                |
| ------------ | --------------------------------------------- |
| 配网提醒     | 配网指示灯闪烁                                |
| 电量采集上报 | 支持                                          |
| 告警触发     | 可配置                                        |
| 防拆触发     | 可配置                                        |
| 故障告警     | 可配置                                        |
| 打印         | 支持，通过定义<br/>`#define ENABLE_TAL_LOG 1` |
| OTA          | 全量OTA-支持<br/>增量OTA-支持(TLSR8258F1KET暂不支持增量OTA)                 |

## 注意事项

| #1   | SDK检测到低功耗设备2min未进入休眠，判定为异常状态，软件触发重启 |
| ---- | ------------------------------------------------------------ |
| #2   | 由涂鸦平台Zigbee方案创建pid的新设备，如未购买涂鸦授权码，将默认限制接入。使用涂鸦APP配网，设备需要经过烧录授权才能接入并识别面板 |
| #3   | 768平台设备编译生成目标文件时，注意编译信息是否提示：<br/>`upgrade firmware size overflow,only support diff ota!`<br/>此提示说明只支持差分方式OTA升级固件。 |



## 编译与烧录

请参考

[快速入门](../../docs/0_快速入门.md)

# FAQ

在使用过程中，如果遇到问题，请访问涂鸦开发者论坛-TuyaOS Zigbee子设备开发板块。您可以：

- 获取开发资料和教程；
- 贡献知识、参与开发者生态建设；
- 反馈SDK使用问题、提交建议；
- 为项目开发寻找合适的解决方法；
- 提交case，寻求帮助；

[中文社区](https://www.tuyaos.com/viewforum.php?f=18)
[英文社区](https://www.tuyaos.com/viewforum.php?f=27)
