#ifndef __APP_H__
#define __APP_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "tal_mf_test.h"

#include "app_common.h"

#include "bsp.h"

typedef UINT8_T REL_STATUS_E;
#ifndef REL_OFF
#define REL_OFF 0
#endif
#ifndef REL_ON
#define REL_ON 1
#endif



typedef struct
{
  UINT8_T   on;
  UINT8_T   led;
  UINT8_T   ledStatus;
  UINT8_T   relStatus;
  UINT8_T   wired_key_count;
  UINT8_T   wired_key_num;
  UINT8_T   ucSwitchType[CHANNEL_NUM];
}receiver_status_t;

#define SLEEP_TIMER_INTERVAL_MS     2000
#define FLASH_TIMER_INTERVAL_MS     2000
// ӳ100ms
#define SLEEP_ALLOW_DELAY_MS        100
#define LONG_ALLOW_DELAY_MS         10

#define LED_STATUS_ZIGBEE_RESET     0x01
#define LED_STATUS_PRESS_SLOW       0x02

typedef struct
{
  // uint8_t   bridge_en;                  // м
  // uint16_t  rel_time[CHANNEL_NUM];     // ʱر
  // uint8_t   zero_cross_disable;         // ̵
  // uint16_t  release_mode[CHANNEL_NUM]; // 㶯
  // CHAR_T    release_buff[13];            // 㶯
  UINT8_T   power_status;               // ϵ״̬
} receiver_config_t;
typedef struct
{
  UINT8_T   on; // ״̬
  // uint8_t on_start; //  
  // uint8_t int_en;   // ״̬ 

} state_config_t;

typedef struct
{
  receiver_config_t device_config;
  state_config_t    state_config;
} __attribute__((packed)) user_flash_store_t;

extern    UINT8_T                 net_count;
extern    UINT8_T                 led_status;
extern    UINT8_T                 general_control;
extern    UINT8_T                 tuya_gpio_key_value_bak;
extern    receiver_status_t       device_status;
extern    user_flash_store_t      user_flash_store;
extern    TIMER_ID                ext_key_allow_timer_id;
extern    TIMER_ID                flash_update_timer_id;
extern    TIMER_ID                update_timer_id;
extern    TIMER_ID                flash_timer_id;
extern    TIMER_ID                zigbee_update_timer_id;

UINT8_T   get_rel_status(UINT8_T channel);
VOID_T    rel_on(UINT8_T channel, report_ctrl_t is_update);
VOID_T    rel_off(UINT8_T channel, report_ctrl_t is_update);
VOID_T    device_init(VOID_T);

#ifdef __cplusplus
}
#endif

#endif
