
#ifndef __TUYA_SDK_CALLBACK_H__
#define __TUYA_SDK_CALLBACK_H__


#ifdef __cplusplus
    extern "C" {
#endif

#include "tuya_cloud_types.h"
#include "tkl_platform_types.h"
#include  "bsp.h"

#define APP_KEY_SUPPORT                           1
#define APP_LED_SUPPORT                           1

// data report info
#define ZCL_ID_ONOFF                              100
#define USER_ZCL_ID                               0x68

// device info
#define ONOFF_1_ENDPOINT                          1
#define ONOFF_2_ENDPOINT                          2
#define ONOFF_3_ENDPOINT                          3
#define ONOFF_4_ENDPOINT                          4
#define APP_ZG_NODE_ROUTER                        0

//led
#define KEY_PIN_1                                 APP_GPIO_PC1
#define LED_PIN_1                                 APP_GPIO_PC4

// ext_key
#define EXT_KEY_PIN_1                             APP_GPIO_PC2
#define EXT_KEY_PIN_2                             APP_GPIO_PB6
#define EXT_KEY_PIN_3                             APP_GPIO_PA0
#define EXT_KEY_PIN_4                             APP_GPIO_PA1

#define KEY_CHANNEL1                              0
#define EXT_KEY_CHANNEL1                          1
#define EXT_KEY_CHANNEL2                          2
#define EXT_KEY_CHANNEL3                          3
#define EXT_KEY_CHANNEL4                          4
#define CHANNEL_MAX                               5

#define SCAN_KEY_IRQ_MODE                         TUYA_GPIO_IRQ_FALL
#define SCAN_EXT_KEY_IRQ_MODE                     TUYA_GPIO_IRQ_RISE_FALL // Ϊ˫ش

// rel
#define REL_PIN_1                                 APP_GPIO_PB5
#define REL_PIN_2                                 APP_GPIO_PB4
#define REL_PIN_3                                 APP_GPIO_PD2
#define REL_PIN_4                                 APP_GPIO_PC3

#define APP_KEY_CONFIG_DEFAULT {                                          \
        {KEY_PIN_1,     SCAN_KEY_IRQ_MODE,     gpio_key_interrupt_handler},                                   \
        {EXT_KEY_PIN_1, SCAN_EXT_KEY_IRQ_MODE, gpio_ext_key_interrupt_handler},      \
        {EXT_KEY_PIN_2, SCAN_EXT_KEY_IRQ_MODE, gpio_ext_key_interrupt_handler},      \
        {EXT_KEY_PIN_3, SCAN_EXT_KEY_IRQ_MODE, gpio_ext_key_interrupt_handler},      \
        {EXT_KEY_PIN_4, SCAN_EXT_KEY_IRQ_MODE, gpio_ext_key_interrupt_handler},      \
}

#define APP_EXT_KEY_CONFIG_DEFAULT {                 \
        {EXT_KEY_PIN_1, SCAN_EXT_KEY_IRQ_MODE},      \
        {EXT_KEY_PIN_2, SCAN_EXT_KEY_IRQ_MODE},      \
        {EXT_KEY_PIN_3, SCAN_EXT_KEY_IRQ_MODE},      \
        {EXT_KEY_PIN_4, SCAN_EXT_KEY_IRQ_MODE},      \
}

// #define APP_EXT_KEY_1_CONFIG_DEFAULT {                                    \
//         {EXT_KEY_PIN_1, SCAN_EXT_KEY_IRQ_MODE, EXT_KEY_CHANNEL1},         \
// }
// #define APP_EXT_KEY_2_CONFIG_DEFAULT {                                    \
//         {EXT_KEY_PIN_2, SCAN_EXT_KEY_IRQ_MODE, EXT_KEY_CHANNEL2},         \
// }
// #define APP_EXT_KEY_3_CONFIG_DEFAULT {                                    \
//         {EXT_KEY_PIN_3, SCAN_EXT_KEY_IRQ_MODE, EXT_KEY_CHANNEL3},         \
// }
// #define APP_EXT_KEY_4_CONFIG_DEFAULT {                                    \
//         {EXT_KEY_PIN_4, SCAN_EXT_KEY_IRQ_MODE, EXT_KEY_CHANNEL4},         \
// }






#ifdef __cplusplus
}
#endif

#endif

