/*
 * @Author: zhangshu
 * @email: shiliang.zhang@tuya.com
 * @LastEditors: Please set LastEditors
 * @file name: app_key.c
 * @Description:
 * @Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
 * @Company: http://www.tuya.com
 * @Date: 2022-02-08
 * @LastEditTime: 2022-02-08
 */
#include "tal_memory.h"
#include "tal_gpio.h"
#include "tkl_gpio.h"
#include "tuya_hal_gpio.h"

#include "bsp.h"
#include "app_common.h"
#include "app_ext_key.h"
#include "app_key.h"
#include "app_mfg.h"
#include "app_battery.h"


VOID_T app_ext_key_gpio_init(VOID_T)
{
  TUYA_GPIO_NUM_E key_pins[CHANNEL_NUM] = {EXT_KEY_PIN_1, EXT_KEY_PIN_2, EXT_KEY_PIN_3, EXT_KEY_PIN_4};
  TUYA_GPIO_BASE_CFG_T status_config;
  status_config.mode = TUYA_GPIO_PULLUP;     // 
  status_config.direct = TUYA_GPIO_INPUT;    // Ϊ뷽
  status_config.level = TUYA_GPIO_LEVEL_LOW; // ʱЧ
  for (size_t i = 0; i < 4; i++)
  {
    tal_gpio_init(key_pins[i], &status_config);
  }
}

OPERATE_RET app_ext_key_oem_init(key_config_t *config)
{
  // tal_key_gpio_init(config, 4, 50, gpio_ext_key_interrupt_handler);
  TAL_PR_TRACE("key init OK!!!");
  return OPRT_OK;
}

UINT8_T gpio_ext_key_read_keys(TUYA_GPIO_NUM_E *key_pins)
{
  UINT8_T key_value = 0;
  UINT8_T read_level;
  UINT8_T i;
  for (i = 0; i < CHANNEL_NUM; i++)
  {
    tkl_gpio_read(key_pins[i], &read_level);
    key_value |= (read_level << i);
  }
  return key_value;
}

// VOID_T user_active_get(TUYA_GPIO_NUM_E *key_pins)
// {
//   UINT8_T i;
//   UINT8_T j;
//   drv_gpioIrqMode_t mode;
//   // for (i = 0; i < CHANNEL_NUM; i++)
//   // {
//   //   j = i;
//   //   check_pin_register(key_pins[i], &j, mode);
//   //   TAL_PR_DEBUG("key_pins[i] %d, j %d, mode %d", key_pins[i], j, mode);
//   // }

// }

// VOID_T key_press_callback(UINT32_T time_ms,UINT8_T index, TUYA_GPIO_NUM_E *key_pins)
// {
//   UINT8_T key_temp;

// }

VOID_T gpio_ext_key_interrupt_handler(UINT32_T ext_key_id, KEY_ST_T key_st, UINT32_T push_time)
{
  TUYA_GPIO_NUM_E key_pins[CHANNEL_NUM] = {EXT_KEY_PIN_1, EXT_KEY_PIN_2, EXT_KEY_PIN_3, EXT_KEY_PIN_4};
  UINT8_T i;
  UINT8_T key_value;
  UINT8_T bit_mask;
  UINT8_T changed_bits;
  UINT8_T key_temp;

  key_value = gpio_ext_key_read_keys(key_pins);
  if (key_value != tuya_gpio_key_value_bak)
  {
    changed_bits = key_value ^ tuya_gpio_key_value_bak;
    for (i = 0; i < CHANNEL_NUM; i++)
    {
      bit_mask = (1 << i);

      if (!(changed_bits & bit_mask))
        continue;

      if (device_status.ucSwitchType[i] == 0)
      {
        if ((key_value & bit_mask) == bit_mask)
        {
          if (device_status.wired_key_count > LONG_PRESS_END && device_status.wired_key_count != LONG_PRESS_TIME_CONST)
          {
            device_status.ucSwitchType[i] = 2;
            device_status.wired_key_count = LONG_PRESS_TIME_CONST;
          }
          else
          {
            device_status.ucSwitchType[i] = 1;
          }
        }
        else
        {

          if (device_status.wired_key_count == LONG_PRESS_TIME_CONST)
          {

            device_status.wired_key_count = LONG_PRESS_TIME_CONST;
            device_status.wired_key_num = i;
            tal_sw_timer_start(ext_key_allow_timer_id, LONG_ALLOW_DELAY_MS, TAL_TIMER_CYCLE);
          }
        }
      }
    }
    for (i = 0; i < CHANNEL_NUM; i++)
    {
      UINT8_T bit_mask = (1 << i);

      if (!(changed_bits & bit_mask))
        continue;

      if (device_status.ucSwitchType[i] == 1)
      {
        TAL_PR_TRACE("Toggle switch %d action", i);
        if (get_rel_status(i))
        {
          rel_off(i, REPORT_ENABLE);
        }
        else
        {
          rel_on(i, REPORT_ENABLE);
        }
      }
      else if (device_status.ucSwitchType[i] == 2)
      {
        if ((key_value & bit_mask) == 0x00)
        {
          if (get_rel_status(i))
          {
            rel_off(i, REPORT_ENABLE);
          }
          else
          {
            rel_on(i, REPORT_ENABLE);
          }
        }
      }
    }
    tuya_gpio_key_value_bak = key_value;
    TAL_PR_TRACE("ext_key_lp_reregister");
    // user_active_get(key_pins);
    // if (key_st == KEY_ST_PUSH)
    // {}
    // else
    // {}
  }
}
