# 产测说明

更新时间：2022-11-04   



## 1. 环境安装
涂鸦提供了专用的产测工具，集成了烧录、授权和产测，方便客户在固件开发完成后进行快速投产。目前产测模式分为两种，一种是用于烧录模组的**云模组授权烧录平台**，另一种是用于对固件功能进行产测的**解决方案产测平台**，前者只会进行烧录授权和必要的模组产测项测试，后者在支持前者功能的基础上也支持对 PCBA 和成品进行复杂的产测功能项进行测试。



### 1.1. PMS账号申请
前往[**涂鸦PMS系统**](https://pms.tuya.com/login)，如果没有PMS系统的账号，需要先注册。

注册流程如下图，选择个人开发者或者公司都是可以的，按照系统注册指引填写相关信息。等邮箱收到涂鸦发送过来的邮件就说明审核已经通过。
![image](https://images.tuyacn.com/fe-static/docs/img/cdd381f3-0d48-4371-ad51-70a86e0818e6.png)



### 1.2. 云模组烧录授权平台

登录涂鸦 PMS 系统，依次点击 知识库管理->软件下载->生产解决方案，开始下载「生产解决方案」工具。
![image](https://images.tuyacn.com/fe-static/docs/img/8051bdba-e72a-4f35-82d5-47d2cb515aac.png)

下载完成后双击进行安装，安装过程中出现以下提示，点击**更多信息**，
![image](https://images.tuyacn.com/fe-static/docs/img/cb46ea9d-9fcd-496b-96b9-8d80be97a8b5.png)

点击**仍要运行**；
![image](https://images.tuyacn.com/fe-static/docs/img/7a11020a-c8ed-40a1-8b72-cb5f657f8537.png)



### 1.3. 解决方案产测平台

目前此软件不开放对外下载，后期会集成到**生产解决方案中**，如果需要使用请联系涂鸦相关产品经理。
**注意**：在安装前请关闭杀毒软件。




## 2. 云模组烧录授权平台使用介绍

双击**生产解决方案**，输入 PMS 注册的账号，进行登录，登录后点击 生产测试->云模组，会自动下载最新的「云模组烧录授权平台」并打开。



### 2.1. 硬件连接

把 Telink 和产测串口连接好，模组产测串口和 Telink 引脚请参见对应模组手册。
![image](https://images.tuyacn.com/rms-static/df1bcc20-5be6-11ed-9d99-a5aaf2a10702-1667528266210.jpg?tyName=b021ad35650ed0c8ced9857c981ecc90.jpg)


| 烧录器  | 模组        |
| :------ | :--------- |
| `SWM`     |   `SWS`  |
| `GND`     |   `GND`  |
| `3V3`     |   `VCC`  |

| 串口  | 模组        |
| :------ | :--------- |
| `TX`     |   `RX PB7`  |
| `RX`     |   `TX PB1`  |
| `RST`    |  `RST 低有效`  |
| `GND`     |   `GND`  |


### 2.2. 软件设置

打开**生产解决方案**，选择云模组；
![image](https://images.tuyacn.com/fe-static/docs/img/a0dc2749-a269-446d-9c89-8740ae6e1338.png)

  

#### 2.2.1. 生产凭证输入

点击输入生产凭证，输入从平台获取到的生产凭证，请注意键入 Enter 按键，后选择**烧录授权**；
![image](https://images.tuyacn.com/rms-static/afcec4d0-5be7-11ed-9d99-a5aaf2a10702-1667528616349.png?tyName=16675285499904.png)

  

#### 2.2.2. 串口和 Telink 设置

选择串口，设置波特率，波特率目前 Zigbee 统一使用 **115200**，信道设置用于进行RF测试，RF测试是用于测试模块无线收发质量，需要配合RF dongle进行使用；
![image](https://images.tuyacn.com/rms-static/afceebe0-5be7-11ed-b55f-0761daf5ff1b-1667528616350.png?tyName=16675285209386.png)

  

#### 2.2.3. 一切准备就绪后点击**运行**即可进行烧录授权。

**注意**：Telink 用于下载固件，串口工具用于进行授权。



## 3. 产测协议使用介绍

[产测协议说明](https://developer.tuya.com/cn/docs/iot/zigbee-production-test-protocol?id=K9fza8q8r7ei8)



## 4. 帮助

请咨询与您对接的涂鸦产品经理。