/**
 * @file tal_zigbee_local_tools.h
 * @brief This is tal_zigbee_local_tools file
 * @version 1.0
 * @date 2022-06-14
 *
 * @copyright Copyright 2021-2022 Tuya Inc. All Rights Reserved.
 *
 */

#ifndef __TAL_ZIGBEE_LOCAL_TOOLS_H__
#define __TAL_ZIGBEE_LOCAL_TOOLS_H__

#include "tuya_cloud_types.h"
#include "tuya_error_code.h"

#ifdef __cplusplus
extern "C" {
#endif

/***********************************************************************
 ********************* constant ( macro and enum ) *********************
 **********************************************************************/


/***********************************************************************
 ********************* struct ******************************************
 **********************************************************************/


/***********************************************************************
 ********************* variable ****************************************
 **********************************************************************/


/***********************************************************************
 ********************* function ****************************************
 **********************************************************************/
/**
 * @brief __sum256
 *
 * @param[in] *data: *data
 * @param[in] len: len
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */
UINT8_T __sum256(UINT8_T *data, UINT8_T len);

/**
 * @brief __crc8
 *
 * @param[in] *vptr: *vptr
 * @param[in] len: len
 *
 * @return OPRT_OK on success. Others on error, please refer to tuya_error_code.h
 */
UINT8_T __crc8(UINT8_T *vptr, UINT8_T len);


#ifdef __cplusplus
}
#endif

#endif /* __TFM_MESH_LOCAL_TOOLS_H__ */

