/*
 * @Author: Deven
 * @Email: liming@tuya.com
 * @LastEditors: Please set LastEditors
 * @FileName: &file name&
 * @Description: 
 * @Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
 * @Company: http://www.tuya.com
 * @Date: 2020-11-07 17:16:29
 * @LastEditTime: 2020-12-16 11:32:22
 */

#ifndef _PACKET_FRAG_H__
#define _PACKET_FRAG_H__


#include "pbuf.h"
#include "mac_net.h"

#ifdef __cplusplus
extern "C" {
#endif

/* packet reassembly structure */
struct reass_data {
    struct reass_data* next;    // next reass_data
    struct pbuf* p;             // point to pbuf data received sequentially
    struct mac_hdr hdr;         // pbuf head
    UINT16_T datagram_len;      // total length of reassembled data(max is 2K)
    UINT8_T tmr;                // packet reassembly max age
};

#define ADDR_AND_SEQNUM_MATCH(hdr1, hdr2)  \
    (MAC_ADDR_CMP(&(hdr1)->src, &(hdr2)->src) && \
    MAC_ADDR_CMP(&(hdr1)->dest, &(hdr2)->dest) && \
    (hdr1)->seqnum == (hdr2)->seqnum) ? 1 : 0

VOID_T packet_reass_tmr(VOID_T);
struct pbuf* packet_reass(struct pbuf* p);
INT8_T packet_frag(struct pbuf* p, struct rf_card* card, const struct mac_addr* dest);

#ifdef __cplusplus
}
#endif

#endif  // end _PACKET_FRAG_H__

