'''
Author: Deven
Email: liming@tuya.com
LastEditors: Please set LastEditors
FileName: &file name&
Description: 
Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
Company: http://www.tuya.com
Date: 2021-10-27 16:16:26
LastEditTime: 2021-11-03 19:14:19
'''
# coding:utf-8
import os
import sys
import yaml
import json
import collections
import shutil
from ruamel.yaml import YAML
from enum import Enum

#*****************************************************************#
# NOTE: This script is a compiled script. Please do not modify it #
#*****************************************************************#
# Pre Build processing.

# Parameter description：
# $1 - Application project name: tuyaos_zigbee_light_sample
# $2 - Application project version: 1.0.0
# python prebuild.py tuyaos_zigbee_light_sample 1.0.0

yaml = YAML(typ='rt')

APP_PATH = sys.argv[1]
APP_PATH = APP_PATH.replace('\\','/') 

CURR_PATH = os.getcwd()
APP_PROJ_PATH = ''
YAML_CONFIG_NAME = './app_config.yaml'
YAML_CONFIG_PATH = os.path.join(APP_PROJ_PATH, YAML_CONFIG_NAME)
JSON_CONFIG_NAME = './appconfig.json'
JSON_CONFIG_PATH = os.path.join(APP_PROJ_PATH, JSON_CONFIG_NAME)
APP_SRC_PATH = os.path.join(APP_PROJ_PATH, 'src')
APP_INC_PATH = os.path.join(APP_PROJ_PATH, 'include')

COPY_SOURCE_PATH = os.path.join(CURR_PATH, 'tools/templates/')

def deldir(dir):
    if not os.path.exists(dir):
        return False
    if os.path.isfile(dir):
        os.remove(dir)
        return
    for i in os.listdir(dir):
        t = os.path.join(dir, i)
        if os.path.isdir(t):
            deldir(t)#重新调用次方法
        else:
            os.unlink(t)
    os.rmdir(dir)#递归删除目录下面的空文件夹

def __load_yaml(fp):
    with open(fp, encoding='utf-8') as f:
        x = yaml.load(f)
    return x

def __check_item_is_none(item):
    if item ==None or item=='':
        return True
    return False


def dev_info_check():
    global DEVICE_ROLE

    os.chdir('../../'+APP_PATH)
    
    fileYml = __load_yaml(YAML_CONFIG_PATH)

    # device role
    DEVICE_ROLE = fileYml['Firmware_Information']['device_role']
    print("Device_role: "+DEVICE_ROLE)
    if __check_item_is_none(DEVICE_ROLE):
        DEVICE_ROLE = 'router'

    return DEVICE_ROLE

# firmware info parser
def json_firmware_info_get():
    global DESCRIPTION
    global MANUFACTURE_ID
    global IMAGE_TYPE

    global MODEL_ID
    global MANUFACTURE_NAME

    global TUYA_PRODUCT_ID
    global TUYA_CAPACITY
    global TUYA_PRODUCT_TYPE

    global MODULE_NAME
    global DEV_ROLE
    global CHIP_ID
    global CUSTOM_COFIG_FLAG

    os.chdir('../../'+APP_PATH)

    try:

        CUSTOM_COFIG_FLAG = True

        file = open(JSON_CONFIG_PATH, 'rb')
        fileJson = json.load(file, object_pairs_hook=collections.OrderedDict)

        DESCRIPTION = fileJson['firmwareInfo']['description']
        MANUFACTURE_ID = fileJson['firmwareInfo']['manufacture_id']
        IMAGE_TYPE = fileJson['firmwareInfo']['image_type']

        MODEL_ID = fileJson['firmwareInfo']['model_id']
        MANUFACTURE_NAME = fileJson['firmwareInfo']['manufacture_name']

        try:
            TUYA_PRODUCT_ID = fileJson['firmwareInfo']['tuya_product_id']
        except Exception as e:
            CUSTOM_COFIG_FLAG = False
            try:
                TUYA_PRODUCT_ID = fileJson['firmwareInfo']['pid']
            except Exception as e:
                print("json parse fail !!! need define tuya_product_id or pid")

        try:
            TUYA_CAPACITY = fileJson['firmwareInfo']['tuya_capacity']
        except Exception as e:
            CUSTOM_COFIG_FLAG = False
            TUYA_CAPACITY = fileJson['firmwareInfo']['manufacture_name']
            MANUFACTURE_NAME = fileJson['firmwareInfo']['manufacture_name']+fileJson['firmwareInfo']['pid']

        try:
            TUYA_PRODUCT_TYPE = fileJson['firmwareInfo']['tuya_product_type']
        except Exception as e:
            CUSTOM_COFIG_FLAG = False
            TUYA_PRODUCT_TYPE = MODEL_ID

        MODULE_NAME = fileJson['firmwareInfo']['module_name']
        DEV_ROLE = fileJson['firmwareInfo']['dev_role']
        CHIP_ID = fileJson['firmwareInfo']['chip_id']

        file.close()
        print("open appconfig.json end!!!")

        return True

    except FileNotFoundError:
        
        return False


def json_transform_to_yaml():

    if os.path.exists('../../'+APP_PATH+'/appconfig.json') and not os.path.exists('../../'+APP_PATH+'/app_config.yaml'):

        if (True == json_firmware_info_get()):

            if True == CUSTOM_COFIG_FLAG:
                shutil.copy2(COPY_SOURCE_PATH+'yaml_demo/custom_app_config.yaml',COPY_SOURCE_PATH+'app_config.yaml')
            else:
                shutil.copy2(COPY_SOURCE_PATH+'yaml_demo/tuya_app_config.yaml',COPY_SOURCE_PATH+'app_config.yaml')

            with open(COPY_SOURCE_PATH+'app_config.yaml', 'r',encoding='utf-8') as file:
                yaml_data = yaml.load(file)

                # 填充新的键和值
                yaml_data['Firmware_Information']['description'] = "this is a demo project"
                yaml_data['Firmware_Information']['device_role'] = DEV_ROLE

                if '0x' in IMAGE_TYPE:
                    yaml_data['Firmware_Information']['image_type'] = int(IMAGE_TYPE,16)
                else:
                    yaml_data['Firmware_Information']['image_type'] = int(IMAGE_TYPE)
                
                if '0x' in MANUFACTURE_ID:
                    yaml_data['Firmware_Information']['manufacture_id'] = int(MANUFACTURE_ID,16)
                else:
                    yaml_data['Firmware_Information']['manufacture_id'] = int(MANUFACTURE_ID)
            
                yaml_data['Firmware_Information']['model_id'] = MODEL_ID
                yaml_data['Firmware_Information']['manufacture_name'] = MANUFACTURE_NAME
                yaml_data['Firmware_Information']['module_name'] = MODULE_NAME
                yaml_data['Firmware_Information']['chip_id'] = CHIP_ID

                if True == CUSTOM_COFIG_FLAG:
                    yaml_data['Firmware_Information']['product_id'] = TUYA_PRODUCT_ID
                    yaml_data['Firmware_Information']['capacity'] = TUYA_CAPACITY
                    yaml_data['Firmware_Information']['product_type'] = TUYA_PRODUCT_TYPE

                # 将更新后的数据写入YAML文件
                with open(COPY_SOURCE_PATH+'app_config.yaml', 'w') as file:
                    yaml.dump(yaml_data, file)

            shutil.copy2(COPY_SOURCE_PATH+'app_config.yaml','../../'+APP_PATH+'/app_config.yaml')
            deldir('../../'+APP_PATH+'/appconfig.json')

        