'''
Author: Deven
Email: liming@tuya.com
LastEditors: Please set LastEditors
FileName: &file name&
Description: 
Copyright: HANGZHOU TUYA INFORMATION TECHNOLOGY CO.,LTD
Company: http://www.tuya.com
Date: 2021-10-27 16:16:26
LastEditTime: 2021-11-03 19:14:19
'''
# coding:utf-8
import os
import sys
import yaml
import collections
from enum import Enum

#*****************************************************************#
# NOTE: This script is a compiled script. Please do not modify it #
#*****************************************************************#
# Pre Build processing.

# Parameter description：
# $1 - Application project name: tuyaos_zigbee_light_sample
# $2 - Application project version: 1.0.0
# python prebuild.py tuyaos_zigbee_light_sample 1.0.0


APP_PATH = sys.argv[1]
APP_PATH = APP_PATH.replace('\\','/') 
APP_NAME = sys.argv[2]
APP_VERSION = sys.argv[3]

CURR_PATH = os.getcwd()
TABLE_SPACE = 40

APP_PROJ_PATH = ''
YAML_CONFIG_NAME = 'app_config.yaml'
YAML_CONFIG_PATH = os.path.join(APP_PROJ_PATH, YAML_CONFIG_NAME)
APP_SRC_PATH = os.path.join(APP_PROJ_PATH, 'src')
APP_INC_PATH = os.path.join(APP_PROJ_PATH, 'include')
CHECK_STRING=APP_NAME+'_'+APP_VERSION

def __load_yaml(fp):
    with open(fp, encoding='utf-8') as f:
        x = yaml.load(f, Loader=yaml.FullLoader)
    return x

# version info convert
def version_string_to_hex(version):
    str = version.replace('.', '')
    strlen = len(str)
    version_hex = ((int(str[0:1]) << 6) & 0xc0) + ((int(str[1:2]) << 4) & 0x30)
    if (strlen > 3) and str[2:4].isdigit():
        version_hex = version_hex + (int(str[2:4]) & 0x0f)
    elif str[2:3].isdigit():
        version_hex = version_hex + (int(str[2:3]) & 0x0f)
    else:
       print("Please enter the correct version number, such as 1.0.0") 
    return version_hex

def __config_tuya_mode_judge(model_id,manu_name):
    if len(manu_name)>=16 and \
    manu_name.startswith("_TZ")==True and \
    (manu_name[7]=='_' or manu_name[14]=='_'):
        return True
    return False

def my_exit():
	deep = 0
	fpids = []
	fpid = os.getpid()
	
	try:
		while True:
			fpid = psutil.Process(fpid).ppid()
			fpids.append(fpid)
			deep = deep +1
	except:
		print(deep)
		if deep > 3:
			sysstr = platform.system()
			if(sysstr =="Windows"):
			   os.popen('taskkill /F /T /PID '+str(fpids[2])) 
			else:
				os.kill(fpids[2],signal.SIGKILL)

def __check_item_is_none(item):
    if item ==None or item=='':
        return True
    return False

class Notice_id(Enum):
    NOTICE_DEV_ROLE=0
    NOTICE_MANU_ID=1
    NOTICE_IMAGE_TYPE=2
    NOTICE_MANU_NAME=3
    NOTICE_PID=4
    NOTICE_CAPACITY=5
    NOTICE_PRODUCT_TYPE=6
    NOTICE_APP_NAME=7
    NOTICE_MODULE_NAME=8
    NOTICE_CHIP_ID=9
    NOTICE_DESCRIPTION=10
    NOTICE_MODEL_ID=11

# name
# Optional value
# default value
BUILD_NOTICE_TBL={
    Notice_id.NOTICE_DEV_ROLE.value:['Device role','router,sleep_end_dev','not defined,you must specify an correct zigbee device role.'],
    Notice_id.NOTICE_MANU_ID.value:["Manufacturer id ","customized",'0x1141'],
    Notice_id.NOTICE_IMAGE_TYPE.value:["Image type ","customized",'0xD3A3'],
    Notice_id.NOTICE_MANU_NAME.value:["Manufacture name ",'you can use customized value or tuya format','not defined'],
    Notice_id.NOTICE_PID.value:["Product id ","None","None"],
    Notice_id.NOTICE_CAPACITY.value:["Capacity ","_TZxxxx_","_TZ3000_"],
    Notice_id.NOTICE_PRODUCT_TYPE.value:["Product type ","https://developer.tuya.com/cn/docs/iot-device-dev/tuya-endtocloud-logic?id=Kav5tfxsbsncf#ModeID","TS0001"],
    Notice_id.NOTICE_APP_NAME.value:["App name ","not defined","not defined"],
    Notice_id.NOTICE_MODULE_NAME.value:["Module name ","ZT3L,ZTLC5,ZTU,ZT5,ZT2S,ZTC etc","not defined"],
    Notice_id.NOTICE_CHIP_ID.value:["Chip id ","TLSR8258F1KET","not defined,you must specify an correct chip!!!"],
    Notice_id.NOTICE_DESCRIPTION.value:["Description ","not defined","not defined"],
    Notice_id.NOTICE_MODEL_ID.value:["Model id ","customized or ref https://developer.tuya.com/cn/docs/iot-device-dev/tuya-endtocloud-logic?id=Kav5tfxsbsncf#ModeID","not defined"],
}
# BUILD_NOTICE_TBL={Notice_id.NOTICE_PID_NOT_MATCH.value:["PID check fail","PID config not match in app_config.yaml","None","None"],
#                   Notice_id.NOTICE_CAPACITY_NOT_MATCH.value:["CAPACITY check fail","CAPACITY config not match in app_config.yaml","_TZxxxx_","_TZ3000_"],
#                   Notice_id.NOTICE_PRODUCT_TYPE_NOT_MATCH.value:["PRODUCT_TYPE check fail","PRODUCT_TYPE config not match in app_config.yaml","https://developer.tuya.com/cn/docs/iot-device-dev/tuya-endtocloud-logic?id=Kav5tfxsbsncf#ModeID","TS0001"],
#                   Notice_id.NOTICE_PID_LEN_ERR.value:["PID check fail","PID length error,must equal 8/16","xxxxxxxx","not defined"],
#                   Notice_id.NOTICE_APP_NAME_TOO_LONG.value:["App name check fail","length do not over 32","not defined","not defined"],
#                   Notice_id.NOTICE_MODULE_NAME_EMPTY.value:["Module name check fail","length do not over 32","not defined","not defined"],
#                   Notice_id.NOTICE_CHIP_ID_ERROR.value:["Chip id check fail","not match","TLSR8258F1KET","not defined,you must specify an correct chip!!!"],
#                 }

def build_notice(id,brief,your_value,exit):
    print('\n###-----------------------------------------------------------------------------###')
    print('###                           TuyaOS SDK build notice                           ###')
    print('###-----------------------------------------------------------------------------###')
    # print(BUILD_NOTICE_TBL[id])
    print('>>> Exceptions   : '+BUILD_NOTICE_TBL[id][0])
    print('>>> Exit         : '+str(exit))
    print('>>> Brief        : '+brief)
    print('>>> Optional     : '+BUILD_NOTICE_TBL[id][1])
    print('>>> Default      : '+BUILD_NOTICE_TBL[id][2])
    print('>>> Yours        : '+your_value)
    print('>>>')
    print('>>>\n>>>-----------------------------------------------------------------------------###')
    print('>>> Refer to the TuyaOS development forum for more details about <app_config.yml>.')
    print('>>> https://www.tuyaos.com/viewtopic.php?t=2633')
    print('###-----------------------------------------------------------------------------###\n')
    if exit == 1:
        my_exit()
        sys.exit(1)

def firmware_info_get():
    global PID
    global DESCRIPTION
    global IMAGE_TYPE
    global MODEL_ID
    global MANUFACTURE_NAME
    global MANUFACTURE_ID
    global MODULE_NAME
    global CHIP_ID
    global DEVICE_ROLE
    global CAPACITY
    global PRODUCT_TYPE

    print("firmware information parse start...")
    fileYml = __load_yaml(YAML_CONFIG_PATH)

    # description
    DESCRIPTION = fileYml['Firmware_Information']['description']
    # print("Descriptions: "+DESCRIPTION)
    if __check_item_is_none(DESCRIPTION):
        build_notice(Notice_id.NOTICE_DESCRIPTION.value,'Description is none','None',1)

    # device role
    DEVICE_ROLE = fileYml['Firmware_Information']['device_role']
    # print("Device_role: "+DEVICE_ROLE)
    if __check_item_is_none(DEVICE_ROLE):
        build_notice(Notice_id.NOTICE_DEV_ROLE.value,'Description is none','None',1)

    # image type
    image_type=fileYml['Firmware_Information']['image_type']
    if __check_item_is_none(image_type):
        build_notice(Notice_id.NOTICE_IMAGE_TYPE.value,'Image type not specified','None',0)
        image_type = 0xD3A3
    IMAGE_TYPE =hex(image_type)
    # print("Image_type: "+IMAGE_TYPE)

    # manufacture id
    manu_id=fileYml['Firmware_Information']['manufacture_id']
    if __check_item_is_none(manu_id):
        build_notice(Notice_id.NOTICE_MANU_ID.value,'manu id not specified','None',0)
        manu_id = 0x1141
    MANUFACTURE_ID = hex(manu_id)
    # print("Manufacture id: "+MANUFACTURE_ID)

    # model id
    MODEL_ID = fileYml['Firmware_Information']['model_id']
    if __check_item_is_none(MODEL_ID):
        build_notice(Notice_id.NOTICE_MODEL_ID.value,'model id is none','None',1)

    # Manufacture name
    MANUFACTURE_NAME = fileYml['Firmware_Information']['manufacture_name']
    if __check_item_is_none(MANUFACTURE_NAME):
        build_notice(Notice_id.NOTICE_MANU_NAME.value,'manu name is none','None',1)

    # PID
    try:
        PID = fileYml['Firmware_Information']['product_id']
    except Exception as ex:
        PID =''
    ty_config_mode=__config_tuya_mode_judge(MODEL_ID,MANUFACTURE_NAME)
    if ty_config_mode==True:
        if len(MANUFACTURE_NAME) >=16 and MANUFACTURE_NAME[7] == '_':
            if PID =='':
                PID = MANUFACTURE_NAME[8:]
            elif PID !=MANUFACTURE_NAME[8:]:
                build_notice(Notice_id.NOTICE_PID.value,'PID config not match in app_config.yaml',PID,1)
        elif len(MANUFACTURE_NAME) >=16 and MANUFACTURE_NAME[14] == '_':
            if PID =='':
                PID = MANUFACTURE_NAME[15:]
            elif PID !=MANUFACTURE_NAME[15:]:
                build_notice(Notice_id.NOTICE_PID.value,'PID config not match in app_config.yaml',PID,1)
    elif PID =='':
        build_notice(Notice_id.NOTICE_PID.value,'PID not specified.','None',1)

    # capacity
    try:
        CAPACITY = fileYml['Firmware_Information']['capacity']
    except Exception as ex:
        CAPACITY =''
    if ty_config_mode==True:
        if len(MANUFACTURE_NAME) >=16 and MANUFACTURE_NAME[7] == '_':
            if CAPACITY =='':
                CAPACITY = MANUFACTURE_NAME[0:8]
            elif CAPACITY !=MANUFACTURE_NAME[0:8]:
                build_notice(Notice_id.NOTICE_CAPACITY.value,'capacity config not match in app_config.yaml',CAPACITY,1)
        elif len(MANUFACTURE_NAME) >=16 and MANUFACTURE_NAME[14] == '_':
            if CAPACITY =='':
                CAPACITY = MANUFACTURE_NAME[0:15]
            elif CAPACITY !=MANUFACTURE_NAME[0:15]:
                build_notice(Notice_id.NOTICE_CAPACITY.value,'capacity config not match in app_config.yaml',CAPACITY,1)
    elif CAPACITY =='':
        build_notice(Notice_id.NOTICE_CAPACITY.value,'capacity not specified.','None',1)
       
    # Product type
    try:
        PRODUCT_TYPE = fileYml['Firmware_Information']['product_type']
    except Exception as ex:
        PRODUCT_TYPE =''

    if ty_config_mode==True:
        if PRODUCT_TYPE =='':
            PRODUCT_TYPE = MODEL_ID
        elif PRODUCT_TYPE !=MODEL_ID:
            build_notice(Notice_id.NOTICE_PRODUCT_TYPE.value,'product type config not match in app_config.yaml' ,PRODUCT_TYPE,1)
    elif PRODUCT_TYPE =='':
        build_notice(Notice_id.NOTICE_PRODUCT_TYPE.value,'product type not specified.','None',1)   

    # module_name
    MODULE_NAME = fileYml['Firmware_Information']['module_name']
    if __check_item_is_none(MODULE_NAME):
        build_notice(Notice_id.NOTICE_MODULE_NAME.value,'model name is none','None',0)
        MODULE_NAME ='ZT3L'  

    # chip_id  
    CHIP_ID = fileYml['Firmware_Information']['chip_id']
    if __check_item_is_none(CHIP_ID):
        build_notice(Notice_id.NOTICE_CHIP_ID.value,'chip id is none','None',0)    
        CHIP_ID ='TLSR8258F1KET'

    print("--- Descriptions: "+DESCRIPTION)
    print("--- Device_role: "+DEVICE_ROLE)
    print("--- Image_type: "+IMAGE_TYPE)
    print("--- Manufacture id: "+MANUFACTURE_ID)
    print("--- Model id: "+MODEL_ID)
    print("--- Manufacture name: "+MANUFACTURE_NAME)
    print('--- Capacity:'+CAPACITY)
    print('--- Product type:'+PRODUCT_TYPE)

    print('--- Module name:'+MODULE_NAME)
    print('--- Chip id:'+CHIP_ID)
    print("firmware information parse success")


# firmware info check
def firmware_info_check():
    if len(PID) !=8 and len(PID) !=16:
        build_notice(Notice_id.NOTICE_PID.value,'PID length must == 8 or 16.',PID,1)

    if IMAGE_TYPE.startswith('0x')==False:
        build_notice(Notice_id.NOTICE_IMAGE_TYPE.value,'format error:eg-0xXXXX!!!.',IMAGE_TYPE,1)
    
    if MANUFACTURE_ID.startswith('0x')==False:
        build_notice(Notice_id.NOTICE_MANU_ID.value,'format error:eg-0xXXXX!!!.',MANUFACTURE_ID,1)

    if CHIP_ID.lower()!='efr32mg21a020f1024im32' and CHIP_ID.lower()!='efr32mg21a020f768im32':
        build_notice(Notice_id.NOTICE_CHIP_ID.value,'chip id is not supported!',CHIP_ID,1)

    if DEVICE_ROLE!='sleep_end_dev' and DEVICE_ROLE!='router':
        build_notice(Notice_id.NOTICE_DEV_ROLE.value,'device role is not supported!',DEVICE_ROLE,1)
    
    if CAPACITY.startswith('_TZ')==False:
        build_notice(Notice_id.NOTICE_CAPACITY.value,'device capacity format error.',CAPACITY,1)

    if len(CAPACITY)!=8:
        build_notice(Notice_id.NOTICE_CAPACITY.value,'device capacity length error.',CAPACITY,1) 

    if len(PRODUCT_TYPE) <6:
        build_notice(Notice_id.NOTICE_PRODUCT_TYPE.value,"product type length error:must greater than 6!!!:%d",PRODUCT_TYPE,1)



# write ifno to generate file
def ato_generate_file_header():
    def wrapper(func):
        def __wrapper(*args,**kwargs):
            print("file generate start...")
            with open(args[0], 'w+') as fileObject:
                fileObject.writelines(
                    "/*************************************************************************************/" + '\n')
                fileObject.writelines("/* Automatically-generated file. Do not edit! */" + '\n')
                fileObject.writelines(
                    "/*************************************************************************************/" + '\n\n')
                fileObject.close()
            return func(*args,**kwargs)
        return __wrapper
    return wrapper


# generat firmware function in config.c
def generate_firmware_func_config_c(fileObj):

    fileObj.writelines("#include \"app_config.h\"" + '\n')
    fileObj.writelines("#include \"tuya_iot_config.h\"" + '\n')
    fileObj.writelines("#include \"tal_firmware_cfg.h\"" + '\n\n\n')

    # generate app info config function
    fileObj.writelines("OPERATE_RET tuya_app_firmware_config(VOID_T)" + '\n')
    fileObj.writelines("{" + '\n')
    fileObj.writelines("    TAL_FW_INIT_T fw_init = {" + '\n')
    fileObj.writelines("        .name = BUILD_FIRMNAME," + '\n')
    fileObj.writelines("        .model_id = APP_MODEL_ID," + '\n')
    fileObj.writelines("        .manu_name = APP_MANUFACTURE_NAME," + '\n')
    fileObj.writelines("        .capacity = APP_CAPACITY," + '\n')
    fileObj.writelines("        .product_id = APP_PRODUCR_ID," + '\n')
    fileObj.writelines("        .product_type = APP_PRODUCT_TYPE," + '\n')
    fileObj.writelines("        .fw_version = FW_VERSION_HEX," + '\n')
    fileObj.writelines("        .manu_id = APP_MANUFACTURE_ID," + '\n')
    fileObj.writelines("        .image_type = APP_IMAGE_TYPE," + '\n')
    fileObj.writelines("    };" + '\n')
    fileObj.writelines("    return tal_firmware_info_init(&fw_init);" + '\n')
    fileObj.writelines("}" + '\n\n\n')

    # generate sdk info config function
    fileObj.writelines("OPERATE_RET tuya_sdk_information_config(VOID_T)" + '\n')
    fileObj.writelines("{" + '\n')
    
    fileObj.writelines("    CHAR_T *sdk_ver = IOT_SDK_VER;" + '\n')
    fileObj.writelines("    CHAR_T *kcfg_ver = \"0.0.0\";" + '\n')
    fileObj.writelines("    CHAR_T *kernel_ver = KERNEL_VERSION;" + '\n')
    fileObj.writelines("    return tal_tuyaos_info_init(sdk_ver, kcfg_ver, kernel_ver);" + '\n')

    fileObj.writelines("}" + '\n\n\n')



# generate config.c file
@ato_generate_file_header()
def ato_generat_sdk_information_c(*args, **kwargs):
    fileObject = open(args[0], 'a+')

    # add func c
    generate_firmware_func_config_c(fileObject)

    fileObject.close()
    print(args[0]+"config file write success")


# generate fimware config
def generate_fimware_macro_config_h(fileObj):

    fileObj.writelines("#define BUILD_FIRMNAME".ljust(TABLE_SPACE) + '\"' + APP_NAME + '\"' + '\n')
    fileObj.writelines("#define FW_VERSION".ljust(TABLE_SPACE)  + '\"'+ APP_VERSION  + '\"'+ '\n')
    fileObj.writelines("#define APP_FIRMWARE_VER".ljust(TABLE_SPACE) + hex(version_string_to_hex(APP_VERSION)) + '\n')
    fileObj.writelines("#define FW_VERSION_HEX".ljust(TABLE_SPACE) + hex(version_string_to_hex(APP_VERSION)) + '\n')
    fileObj.writelines("#define APP_DEV_ROLE".ljust(TABLE_SPACE) + '\"' + DEVICE_ROLE + '\"' + '\n')
    fileObj.writelines("#define APP_MANUFACTURE_ID".ljust(TABLE_SPACE) + MANUFACTURE_ID + '\n')
    fileObj.writelines("#define APP_IMAGE_TYPE".ljust(TABLE_SPACE) + IMAGE_TYPE + '\n')
    fileObj.writelines("#define APP_MODEL_ID".ljust(TABLE_SPACE) + '\"' + MODEL_ID + '\"' + '\n')
    fileObj.writelines("#define APP_MANUFACTURE_NAME".ljust(TABLE_SPACE) + '\"' + MANUFACTURE_NAME + '\"' + '\n')
    
    fileObj.writelines("#define APP_PRODUCR_ID".ljust(TABLE_SPACE) + '\"' + PID + '\"' + '\n')
    fileObj.writelines("#define APP_CAPACITY".ljust(TABLE_SPACE) + '\"' + CAPACITY + '\"' + '\n')
    fileObj.writelines("#define APP_PRODUCT_TYPE".ljust(TABLE_SPACE) + '\"' + PRODUCT_TYPE + '\"' + '\n')
    fileObj.writelines("#define MODULE_NAME".ljust(TABLE_SPACE) + '\"' + MODULE_NAME + '\"' + '\n')
    fileObj.writelines("#define CHIP_ID".ljust(TABLE_SPACE) + '\"' + CHIP_ID + '\"' + '\n\n\n')


# generate config.h file
@ato_generate_file_header()
def ato_generate_config_h(*args, **kwargs):

    try:
        if os.path.exists(args[1]):
            print("legacy app_config.h file exists,delete.")
            os.remove(args[1])
    except Exception as ex:
        print()

    with open(args[0], 'a') as fileObject:

        fileObject.writelines("#ifndef __APP_CONFIG_H__" + '\n')
        fileObject.writelines("#define __APP_CONFIG_H__" + '\n\n')
        fileObject.writelines("/* automatically generated app firmware information! */" + '\n')
        # add macro
        generate_fimware_macro_config_h(fileObject)
        fileObject.writelines('\n' + "#endif" + '\n')
        fileObject.close()

    print(args[0]+"\nconfig file write success")

# if __name__ == "__main__":
#     os.chdir('../../'+APP_PATH)
#     firmware_info_get()
#     inc_path = os.path.join(APP_INC_PATH, 'app_config.h')
#     src_path = os.path.join(APP_SRC_PATH, 'app_config.c')
#     ato_generate_config_h(inc_path)
#     ato_generat_sdk_information_c(src_path)
#     os.chdir(CURR_PATH)

def Pre_build():
    if len(APP_NAME) > 32:
        build_notice(Notice_id.NOTICE_APP_NAME.value,
                       'raw application name too long. MUST <= 32,please check!!!',
                       CHECK_STRING,
                       1)
    if len(CHECK_STRING) > 32:
        build_notice(Notice_id.NOTICE_APP_NAME.value,
                       'application name length MUST <= 25 if you use gatway manufacture test,otherwise,you can ignore it!!!',
                       CHECK_STRING,
                       0)
    os.chdir('../../'+APP_PATH)
    firmware_info_get()
    inc_path = os.path.join(APP_INC_PATH, 'app_config.h')
    src_path = os.path.join(APP_SRC_PATH, 'app_config.c')
    ato_generate_config_h('./'+'app_config.h',inc_path)
    ato_generat_sdk_information_c(src_path)
    os.chdir(CURR_PATH)


